VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsInternet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'##################################################
'# @author : Matthias Bartelt                     #
'# @version: 0.0                                  #
'##################################################
'# @Option   : Everything with the Internet.      #
'##################################################

'### Variables must be declared
Option Explicit



'##################################################
'###              DECLARATIONS                  ###
'##################################################

'### API
Private Declare Function GetHostByName Lib "wsock32.dll" Alias "gethostbyname" (ByVal Hostname As String) As Long
Private Declare Function IcmpCreateFile Lib "icmp.dll" () As Long
Private Declare Function IcmpCloseHandle Lib "icmp.dll" (ByVal HANDLE As Long) As Boolean
Private Declare Function IcmpSendEcho Lib "ICMP" (ByVal IcmpHandle As Long, ByVal DestAddress As Long, ByVal RequestData As String, ByVal RequestSize As Integer, RequestOptns As IP_OPTION_INFORMATION, ReplyBuffer As IP_ECHO_REPLY, ByVal ReplySize As Long, ByVal TimeOut As Long) As Boolean
Private Declare Function InternetCloseHandle Lib "wininet" (ByVal hInet As Long) As Integer
Private Declare Function InternetReadFile Lib "wininet" (ByVal hFile As Long, ByVal sBuffer As String, ByVal lNumBytesToRead As Long, lNumberOfBytesRead As Long) As Integer
Private Declare Function InternetOpen Lib "wininet" Alias "InternetOpenA" (ByVal sAgent As String, ByVal lAccessType As Long, ByVal sProxyName As String, ByVal sProxyBypass As String, ByVal lFlags As Long) As Long
Private Declare Function InternetOpenUrl Lib "wininet" Alias "InternetOpenUrlA" (ByVal hInternetSession As Long, ByVal lpszUrl As String, ByVal lpszHeaders As String, ByVal dwHeadersLength As Long, ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function WSACleanup Lib "wsock32.dll" () As Long
Private Declare Function WSAStartup Lib "wsock32.dll" (ByVal wVersionRequired&, lpWSAdata As WSAdata) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

'### Constants
Private Const SOCKET_ERROR              As Long = 0
Private Const INTERNET_OPEN_TYPE_DIRECT As Long = 1
Private Const INTERNET_FLAG_RELOAD      As Long = &H80000000
'### Types
Private Type Hostent
    h_name                              As Long
    h_aliases                           As Long
    h_addrtype                          As Integer
    h_length                            As Integer
    h_addr_list                         As Long
End Type
'---
Private Type IP_OPTION_INFORMATION
    TTL                                 As Byte
    Tos                                 As Byte
    Flags                               As Byte
    OptionsSize                         As Long
    OptionsData                         As String * 128
End Type
'---
Private Type IP_ECHO_REPLY
    Address(0 To 3)                     As Byte
    Status                              As Long
    RoundTripTime                       As Long
    DataSize                            As Integer
    Reserved                            As Integer
    data                                As Long
    Options                             As IP_OPTION_INFORMATION
End Type
'---
Private Type WSAdata
    wVersion                            As Integer
    wHighVersion                        As Integer
    szDescription(0 To 255)             As Byte
    szSystemStatus(0 To 128)            As Byte
    iMaxSockets                         As Integer
    iMaxUdpDg                           As Integer
    lpVendorInfo                        As Long
End Type



'##################################################
'###                  EVENTS                    ###
'##################################################



'##################################################
'###                 METHODS                    ###
'##################################################

Public Function fCheckMailAddress(ByRef sString As String) As Boolean
'### @info: Is it a valid mail address

'Handle errors
On Error Resume Next

    'Check the string
    Let fCheckMailAddress = (sString Like "*@*.*")

End Function

Public Sub sOpenLink(ByVal sLink As String)
'### @info: Open a link

'Handle errors
On Error Resume Next

    'Open the link
    Call ShellExecute(ByVal 0&, vbNullString, sLink, vbNullString, "C:\", 1)

End Sub

Public Function fOpenFile(ByVal sFileURL As String, Optional ByVal lBufferSize As Long = 1024, _
    Optional ByVal bReturnValue As Boolean = True) As String
'### @info: Open a file from the internet

'Handle errors
On Error Resume Next

    'Variables
    Dim hFile   As Long
    Dim hOpen   As Long
    Dim lResult As Long
    Dim sBuffer As String

    sBuffer = Space(lBufferSize)
    DoEvents

    'Open a connection
    hOpen = InternetOpen(App.EXEName, INTERNET_OPEN_TYPE_DIRECT, vbNullString, vbNullString, 0)
    
    'Send the error string to the PHP script
    hFile = InternetOpenUrl(hOpen, sFileURL, vbNullString, ByVal 0&, INTERNET_FLAG_RELOAD, ByVal 0&)
    
    'Close the connection
    Call InternetReadFile(hFile, sBuffer, lBufferSize, lResult)
    Call InternetCloseHandle(hFile)
    Call InternetCloseHandle(hOpen)
    
    'Return the value
    If (bReturnValue) Then Let fOpenFile = Left(sBuffer, lResult)
                
End Function

Public Function fPingServer(ByVal sServerAddress As String) As Long
'### @info: Play a sound from the system theme

'Handle errors
On Error GoTo errError

    'Variables
    Dim hFile        As Long
    Dim lAddressList As Long
    Dim nHostent     As Hostent
    Dim nOptionInfo  As IP_OPTION_INFORMATION
    Dim nEchoReply   As IP_ECHO_REPLY
    Dim nWSData      As WSAdata
    Dim sAddress     As Long
    Dim sIPAddress   As String
    
    'Set the start value
    Let fPingServer = 0
    
    'Remove "http"
    If (Left(sServerAddress, 7) = "http://") Then Let sServerAddress = Mid(sServerAddress, 8)
    
    Call WSAStartup(&H101, nWSData)
    
    DoEvents
    
    'Get the host name
    If (GetHostByName(sServerAddress + String(64 - Len(sServerAddress), 0)) <> SOCKET_ERROR) Then
        Call CopyMemory(nHostent.h_name, ByVal GetHostByName(sServerAddress + String(64 - Len(sServerAddress), 0)), Len(nHostent))
        Call CopyMemory(lAddressList, ByVal nHostent.h_addr_list, 4)
        Call CopyMemory(sAddress, ByVal lAddressList, 4)
    End If
    
    hFile = IcmpCreateFile()
    If (hFile = 0) Then Exit Function
    
    nOptionInfo.TTL = 255
    
    DoEvents
    
    'Send the ping request
    If (IcmpSendEcho(hFile, sAddress, String(32, "A"), 32, nOptionInfo, nEchoReply, Len(nEchoReply) + 8, 2000)) Then
        Let sIPAddress = CStr(nEchoReply.Address(0)) + "." + CStr(nEchoReply.Address(1)) + _
            "." + CStr(nEchoReply.Address(2)) + "." + CStr(nEchoReply.Address(3))
    Else
        Exit Function
    End If
    
    'Return the ping
    If (nEchoReply.Status = 0) Then Let fPingServer = nEchoReply.RoundTripTime

   
   Exit Function
   
errError:
   Let fPingServer = -1
   
End Function


'##################################################
'###                PROPERTIES                  ###
'##################################################

