VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSystem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'##################################################
'# @author : Matthias Bartelt                     #
'# @version: 0.0                                  #
'##################################################
'# @info   : Everything done with the system.     #
'##################################################

'### Variables must be declared
Option Explicit



'##################################################
'###              DECLARATIONS                  ###
'##################################################

'### API
Private Declare Function AdjustTokenPrivileges Lib "advapi32" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function ExitWindowsEx Lib "user32" (ByVal dwOptions As Long, ByVal dwReserved As Long) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
Private Declare Function GetMenu Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Integer
Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hWnd As Long, lpdwProcessId As Long) As Long
Private Declare Function LookupPrivilegeValue Lib "advapi32" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Private Declare Function OpenProcessToken Lib "advapi32" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Any, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegFlushKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Any) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Long, ByVal cbData As Long) As Long
Private Declare Function RegSetValueEx_Str Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function SetLayeredWindowAttributes Lib "user32.dll" (ByVal hWnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
Private Declare Function SetMenuItemBitmaps Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal hBitmapUnchecked As Long, ByVal hBitmapChecked As Long) As Long
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
       
'### Constants
Private Const ERROR_SUCCESS              As Long = 0&
Private Const EWX_LOGOFF                 As Long = 0
Private Const EWX_SHUTDOWN               As Long = 1
Private Const EWX_REBOOT                 As Long = 2
Private Const EWX_FORCE                  As Long = 4
Private Const EWX_POWEROFF               As Long = 8
Private Const EWX_FORCEIFHUNG            As Long = 16
Private Const GWL_EXSTYLE                As Long = (-20)
Private Const KEY_QUERY_VALUE            As Long = &H1
Private Const KEY_SET_VALUE              As Long = &H2
Private Const KEY_sCreate_SUB_KEY        As Long = &H4
Private Const KEY_ENUMERATE_SUB_KEYS     As Long = &H8
Private Const KEY_NOTIFY                 As Long = &H10
Private Const KEY_sCreate_LINK           As Long = &H20
Private Const KEY_READ = KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Private Const KEY_ALL_ACCESS = KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_sCreate_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_sCreate_LINK
Private Const LWA_ALPHA                  As Long = &H2
Private Const MF_BYPOSITION              As Long = &H400
Private Const PROCESS_TERMINATE          As Long = &H1
Private Const REG_NONE                   As Long = 0
Private Const REG_SZ                     As Long = 1
Private Const REG_EXPAND_SZ              As Long = 2
Private Const REG_BINARY                 As Long = 3
Private Const REG_DWORD                  As Long = 4
Private Const REG_DWORD_LITTLE_ENDIAN    As Long = 4
Private Const REG_DWORD_BIG_ENDIAN       As Long = 5
Private Const REG_LINK                   As Long = 6
Private Const REG_MULTI_SZ               As Long = 7
Private Const REG_OPTION_NON_VOLATILE    As Long = &H0
Private Const VER_PLATFORM_WIN32s        As Long = 0
Private Const VER_PLATFORM_WIN32_WINDOWS As Long = 1
Private Const VER_PLATFORM_WIN32_NT      As Long = 2
Private Const WS_EX_LAYERED              As Long = &H80000

'### Enums
Public Enum OS_Version
    Unknown
    Win32s
    Win95
    Win98
    Win98SE
    WinME
    WinNT
    Win2000
    WinXP
End Enum
'---
Public Enum Registry_Roots
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum

'### Types
Private Type LUID
    UsedPart                             As Long
    IgnoredForNowHigh32BitPart           As Long
End Type
'---
Private Type TOKEN_PRIVILEGES
    PrivilegeCount                       As Long
    TheLuid                              As LUID
    Attributes                           As Long
End Type
'---
Private Type OSVERSIONINFO
    dwOSVersionInfoSize                  As Long
    dwMajorVersion                       As Long
    dwMinorVersion                       As Long
    dwBuildNumber                        As Long
    dwPlatformId                         As Long
    szCSDVersion                         As String * 128
End Type



'##################################################
'###                  EVENTS                    ###
'##################################################

Private Sub Class_Initialize()
'### @info: Called if somebody create a new instance of this class

    'Set the default values

End Sub



'##################################################
'###                 METHODS                    ###
'##################################################

Public Function fDirExist(ByVal sDirPath As String) As Boolean
'### @info: Check if a file exist

'Ignore all errors
On Error Resume Next

    'Check if the file exist
    Let fDirExist = Not (Dir(sDirPath, vbDirectory) = "")

End Function

Public Function fFileExist(ByVal sFilePath As String) As Boolean
'### @info: Check if a file exist

'Ignore all errors
On Error Resume Next

    'Check if the file exist
    Let fFileExist = Not (Dir(sFilePath, vbHidden Or vbNormal Or vbReadOnly) = "")

End Function

Public Sub sFileOpen(ByVal sFilePath As String, ByVal lHwnd As Long, Optional ByVal sRoot As String = "C:\")
'### @info: Open a file

'Ignore all errors
On Error Resume Next

    'Open the file
    Call ShellExecute(lHwnd, "Open", sFilePath, "", sRoot, 1)

End Sub

Public Sub sSystem_PowerOff()
'### @info: Shut off the computer

'Ignore all errors
On Error Resume Next

    'Check the system
    If (fGetOS = Win2000) Or (fGetOS = WinNT) Or (fGetOS = WinXP) _
        Then Call sSetShutdownPrivilege
    
    'Shutdown the system
    Call ExitWindowsEx(EWX_POWEROFF Or EWX_FORCE, &HFFFF)

End Sub

Public Sub sTransparentForm(ByVal hWnd As Long, ByVal bytValue As Byte)
'### @info: Make a form transparent

'Ignore all errors
On Error Resume Next

    'Check the oprating system
    If (fGetOS = Win2000) Or (fGetOS = WinXP) Then
        'Variables
        Dim lWndStyle As Long
        
        'Get the window's style
        Let lWndStyle = GetWindowLong(hWnd, GWL_EXSTYLE)
        
        'Make it transparent
        If (bytValue < 255) Then
            Let lWndStyle = (lWndStyle Or WS_EX_LAYERED)
            Call SetWindowLong(hWnd, GWL_EXSTYLE, lWndStyle)
            Call SetLayeredWindowAttributes(hWnd, 0, bytValue, LWA_ALPHA)
        Else
            'Reset the form to the default style
            Let lWndStyle = (lWndStyle Xor WS_EX_LAYERED)
            Call SetWindowLong(hWnd, GWL_EXSTYLE, lWndStyle)
        End If
    End If
    
End Sub

Public Sub sSetMenuBitmap(ByVal hWindow As Long, ByVal lMenu As Long, ByVal lSubMenu As Long, ByRef oBitmap As StdPicture)
'### @info: Set a bitmap to a menu

'Ignore all errors
On Error Resume Next

    'Variables
    Dim hMenu    As Long
    Dim hMenuSub As Long
    
    'Get the menu
    Let hMenu = GetMenu(hWindow)
    
    'Get the submenu
    Let hMenuSub = GetSubMenu(hMenu, lMenu)

    'Set the picture
    Call SetMenuItemBitmaps(hMenuSub, lSubMenu, MF_BYPOSITION, oBitmap, oBitmap)

End Sub


Private Sub sSetShutdownPrivilege()
'### @info: Set the privileges to shutdown the pc

'Ignore all errors
On Error Resume Next

    'Constants
    Const TOKEN_ADJUST_PRIVILEGES As Long = &H20
    Const TOKEN_QUERY             As Long = &H8
    Const SE_PRIVILEGE_ENABLED    As Long = &H2
    
    'Variables
    Dim hProcessHandle            As Long
    Dim hTokenHandle              As Long
    Dim nPrivilegeLUID            As LUID
    Dim nTokenPrivs               As TOKEN_PRIVILEGES
    Dim nTokenTemp                As TOKEN_PRIVILEGES
    Dim lResult                   As Long

    'Get the handle of the current process
    Let hProcessHandle = GetCurrentProcess()
    
    'Change the token
    Call OpenProcessToken(hProcessHandle, (TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY), hTokenHandle)
    
    'Get the LUID
    Call LookupPrivilegeValue("", "SeShutdownPrivilege", nPrivilegeLUID)
    
    'Change the token
    With nTokenPrivs
        'Amount of previleges
        Let .PrivilegeCount = 1
        'LUID structure
        Let .TheLuid = nPrivilegeLUID
        'Set the new privilege
        Let .Attributes = SE_PRIVILEGE_ENABLED
    End With
    
    'Now set the token for the process
    Call AdjustTokenPrivileges(hTokenHandle, False, nTokenPrivs, Len(nTokenTemp), nTokenTemp, lResult)
    
    'Close the handle
    Call CloseHandle(hTokenHandle)
    
End Sub

Private Sub sTerminateExplorer()
'### @info: Terminate the explorer

'Ignore all errors
On Error Resume Next

    'Variables
    Dim hExplorerWnd As Long
    Dim hProcess     As Long
    Dim lProcessID   As Long

    'Get the window handle
    Let hExplorerWnd = FindWindow("progman", "program manager")
    
    'Get the processID
    Call GetWindowThreadProcessId(hExplorerWnd, lProcessID)
    
    'Open the process
    hProcess = OpenProcess(PROCESS_TERMINATE, 0&, lProcessID)
    
    'Terminate it
    If Not (hProcess = 0) Then Call TerminateProcess(hProcess, 1&)
    
    'Close the handle for the process
    Call CloseHandle(hProcess)
  
End Sub

Public Function fGetOS() As OS_Version
'### @info: Get the operating system

'Ignore all errors
On Error Resume Next

    'Variables
    Dim lBuildNr       As Long
    Dim nOSVersionInfo As OSVERSIONINFO
    Dim nVersion       As OS_Version

    'Get the version
    Let nOSVersionInfo.dwOSVersionInfoSize = Len(nOSVersionInfo)
    Call GetVersionEx(nOSVersionInfo)
    
    'Set the default value
    Let nVersion = Unknown

    With nOSVersionInfo
        'Check the build numer
        Let lBuildNr = (.dwBuildNumber And &HFFFF&) - (IIf((.dwBuildNumber And &HFFFF&) > &H7FFF, &H10000, 0))

        'Check the platform
        If (.dwPlatformId = VER_PLATFORM_WIN32_NT) Then
            If (.dwMajorVersion = 4) Then
                Let nVersion = WinNT
            ElseIf (.dwMajorVersion = 5) Then
                If (.dwMinorVersion = 0) Then
                    Let nVersion = Win2000
                ElseIf (.dwMinorVersion = 1) Then
                    Let nVersion = WinXP
                End If
            End If
        ElseIf (.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS) Then
            If (.dwMajorVersion > 4) Or (.dwMajorVersion = 4 And .dwMinorVersion = 10) Then
                If (lBuildNr = 1998) Then
                    Let nVersion = Win98
                Else
                    Let nVersion = Win98SE
                End If
            ElseIf (.dwMajorVersion = 4 And .dwMinorVersion = 0) Then
                Let nVersion = Win95
            ElseIf (.dwMajorVersion = 4 And .dwMinorVersion = 90) Then
                Let nVersion = WinME
            End If
        ElseIf (.dwPlatformId = VER_PLATFORM_WIN32s) Then
            Let nVersion = Win32s
        End If
    End With
    
    'Return the value
    Let fGetOS = nVersion
    
End Function

Public Function fRegistry_GetValue(ByVal lRoot As Registry_Roots, ByVal sKey As String, ByVal sField As String) As String

'Process the error
On Error GoTo errError

    'Variables
    Dim hKey    As Long
    Dim lBuffer As Long
    Dim lResult As Long
    Dim lType   As Long
    Dim sBuffer As String
    Dim sValue  As String

    'Read the value from the registry
    Let lResult = RegOpenKeyEx(lRoot, sKey, 0, KEY_READ, hKey)
    
    If (lResult = ERROR_SUCCESS) Then
        Let lResult = RegQueryValueEx(hKey, sField, ByVal 0&, lType, ByVal 0&, lBuffer)
        If (lResult = ERROR_SUCCESS) Then
            Select Case lType
                Case REG_SZ, REG_EXPAND_SZ
                    Let sBuffer = Space(lBuffer - 1)
                    Let lResult = RegQueryValueEx(hKey, sField, 0&, lType, ByVal sBuffer, lBuffer)
                    If (lResult = ERROR_SUCCESS) Then sValue = sBuffer
                Case REG_DWORD
                    Let lResult = RegQueryValueEx(hKey, sField, 0&, lType, lBuffer, lBuffer)
                    If (lResult = ERROR_SUCCESS) Then sValue = lBuffer
            End Select
        End If
    End If
    
    'Return the value
    If (lResult = ERROR_SUCCESS) Then Let lResult = RegCloseKey(hKey)
    Let fRegistry_GetValue = sValue
            
    Exit Function
    
errError:
    'No value
    Let fRegistry_GetValue = ""
    
End Function

Public Sub sRegistry_SetValue(ByVal lRoot As Registry_Roots, ByVal sKey As String, ByVal sField As String, ByVal sValue As String)
'### @info: Set a value to the registry

'Process the error
On Error GoTo errError

    'Variables
    Dim hKey    As Long
    Dim lResult As Long
  
    'Wert in ein Feld der Registry schreiben
    Let lResult = RegOpenKeyEx(lRoot, sKey, 0, KEY_ALL_ACCESS, hKey)
    If (lResult = ERROR_SUCCESS) Then
        Let lResult = RegSetValueEx_Str(hKey, sField, 0, REG_SZ, sValue, Len(sValue) + 1)
        Let lResult = RegCloseKey(hKey)
    End If
   
    Exit Sub
    
errError:
    
End Sub

Public Sub sRegistry_DeleteValue(ByVal lRoot As Registry_Roots, ByVal sKey As String, ByVal sField As String)
'### @info: Delete a value form the registry

'Process the error
On Error GoTo errError

    'Variables
    Dim hKey    As Long
    Dim lResult As Long

    'Delete the values
    Let lResult = RegOpenKeyEx(lRoot, sKey, 0, KEY_ALL_ACCESS, hKey)
    If lResult = ERROR_SUCCESS Then
        Let lResult = RegDeleteValue(hKey, sField)
        Let lResult = RegCloseKey(hKey)
    End If

    Exit Sub
    
errError:

End Sub


'##################################################
'###                PROPERTIES                  ###
'##################################################

Public Property Get pInfo_Event() As Event_Type

    'Return the hours

End Property
'###########
Public Property Let pInfo_Event(ByVal eNewValue As Event_Type)

    'Set the new hours value

End Property
'##################################################
