VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTimeEvent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'##################################################
'# @author : Matthias Bartelt                     #
'# @version: 0.0                                  #
'##################################################
'# @info   : Save and hanle program options.      #
'##################################################

'### Variables must be declared
Option Explicit



'##################################################
'###              DECLARATIONS                  ###
'##################################################

'### Constants (Defaults)
Private Const m_Def_eEvent       As Long = 0
Private Const m_Def_lTime_Hour   As Long = 0
Private Const m_Def_lTime_Minute As Long = 0

'### Enums
Public Enum Event_Type
    NoEvent = 0
    Player_Pause = 1
    Player_Play = 2
End Enum

'### Variables
Private m_eEvent                 As Event_Type
Private m_lTime_Hour             As Long
Private m_lTime_Minute           As Long



'##################################################
'###                  EVENTS                    ###
'##################################################

Private Sub Class_Initialize()
'### @info: Called if somebody create a new instance of this class

    'Set the default values
    Let m_eEvent = m_Def_eEvent
    Let m_lTime_Hour = m_Def_lTime_Hour
    Let m_lTime_Minute = m_Def_lTime_Minute

End Sub



'##################################################
'###                 METHODS                    ###
'##################################################

Public Function fCheckEvent() As Event_Type
'### @info: Check if the time is reached
    
'Ignore all errors
On Error Resume Next

    'Check the time
    If (m_lTime_Hour = Hour(Now)) And (m_lTime_Minute = Minute(Now)) Then
        'Raise the event
        fCheckEvent = m_eEvent
        Exit Function
    End If

    'No event
    fCheckEvent = NoEvent

End Function



'##################################################
'###                PROPERTIES                  ###
'##################################################

Public Property Get pInfo_Event() As Event_Type

    'Return the hours
    Let pInfo_Event = m_eEvent

End Property
'###########
Public Property Let pInfo_Event(ByVal eNewValue As Event_Type)

    'Set the new hours value
    Let m_eEvent = eNewValue

End Property
'##################################################
Public Property Get pTime_Hour() As Long

    'Return the hours
    Let pTime_Hour = m_lTime_Hour

End Property
'###########
Public Property Let pTime_Hour(ByVal lNewValue As Long)

    'Check the new value
    If (lNewValue < 0) Or (lNewValue > 23) Then lNewValue = 0

    'Set the new hours value
    Let m_lTime_Hour = lNewValue

End Property
'##################################################
Public Property Get pTime_Minute() As Long

    'Return the minutes
    Let pTime_Minute = m_lTime_Minute

End Property
'###########
Public Property Let pTime_Minute(ByVal lNewValue As Long)

    'Check the new value
    If (lNewValue < 0) Or (lNewValue > 59) Then lNewValue = 0

    'Set the new minutes value
    Let m_lTime_Minute = lNewValue

End Property
'##################################################
